/*
// Created by Tiny on 3/3/2021.
*/

/*!
 * \file GAME.h
 * \brief Game Header File
 * \authors Tin
 * \version 1
 * \date 03/03/2021
 *
 * Game definition.
 *
 */

#ifndef INSAGAME_GAME_H
#define INSAGAME_GAME_H


#include <SDL2/SDL.h>
#include "personnage.h"
#include "prof.h"
#include "DS.h"
#include "map.h"
#include "window.h"
/*!
 * \def WINDOW_WIDTH
 * \brief The window's width.
 */
#define WINDOW_WIDTH 700
/*!
 * \def WINDOW_HEIGHT
 * \brief The window's height.
 */
#define WINDOW_HEIGHT 700

/*!
 * \def SPEED
 * \brief General speed.
 */
#define SPEED 5




SDL_Texture * query_exam(DS * exam, SDL_Rect * exam_rect, SDL_Renderer * renderer, SDL_Window * window);
SDL_Texture * query_map(MAP * map, SDL_Renderer * renderer, SDL_Window * window);
SDL_Texture * query_heart(SDL_Rect * heart_rect,SDL_Renderer * renderer, SDL_Window * window, char * path);
SDL_Texture * query_score(SDL_Renderer *renderer, SDL_Rect* score_rect, SDL_Window * window, int* score);

void copy_hero(Personnage * hero, SDL_Rect * hero_rect, SDL_Renderer * renderer, SDL_Texture ** container_textures_hero);

void load_timer_textures(SDL_Renderer * renderer, SDL_Texture ** container_timer, int number_second_max);

void load_hero_textures(SDL_Renderer * renderer, SDL_Texture ** container_textures_hero);

void load_teacher_textures(SDL_Renderer * renderer, SDL_Texture ** container_textures_teacher);

void copy_teacher(Prof * teacher, SDL_Rect * teacher_rect, SDL_Renderer * renderer, SDL_Texture ** container_textures_teacher);

void free_Textures(SDL_Texture ** container, int number);


int show_image_in_time(SDL_Renderer* renderer, SDL_Window * window, char * path, int time);


int calculer_score(Personnage * hero, int time_remaining, Window * window_play);


void test_event_hero(Personnage * hero, SDL_Event * event, int * close);
void test_event_hero_inverse(Personnage * hero, SDL_Event * event, int * close);
void test_event_hero_combinatoire(Personnage * hero, SDL_Event * event, int * close, int key_combinatoire);


#endif /*INSAGAME_GAME_H*/
