/*
// Created by Lucile on 04/04/2021.
*/

/*!
 * \file window.h
 * \brief Window Header File
 * \authors Lucile
 * \version 2
 * \date 04/04/2021
 *
 * Window structure definiton.
 *
 */

#ifndef INSAGAME_WINDOW_H
#define INSAGAME_WINDOW_H

#include <SDL2/SDL.h>
#include <SDL2/SDL_mixer.h>
#include <SDL2/SDL_image.h>
#include "personnage.h"


/*!
 * \enum Window_number
 * \brief Definiton of every window's number
 */

typedef enum {
    INTRO_PAGE, /*!< 0 */
    LEVEL, /*!< 1 */
    WIN_PAGE, /*!< 2 */
    FAIL_PAGE /*!< 3 */
} Window_number;


/*!
 * \struct Window
 * \brief Window structure
 */

typedef struct {
    int level; /**< Level integer */
    int time; /**< Level's time */
    Window_number id_window; /**< Window's number */
} Window;


void init_window(Window * window, int level, int time, int id_window);

void intro_page(SDL_Renderer * renderer,Window * window_play, int *close_request);
void win_page(SDL_Window * window, SDL_Renderer * renderer,Window * window_play, Personnage * hero, int *close_request, int *time_remaining);
void lose_page(SDL_Window * window, SDL_Renderer * renderer,Window * window_play, Personnage * hero, int *close_request, int *time_remaining);
void level_1(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_2(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_3(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_4(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_5(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_6(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_7(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_8(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_9(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remaining);
void level_10(SDL_Renderer * renderer, SDL_Window * window, Personnage * hero, Window * window_play, int * close_request, int * time_remainin);









#endif /*INSAGAME_WINDOW_H*/
