/*
// Created by Kaan on 8.05.2021.
*/

#ifndef INSAGAME_TEST_MOVE_H
#define INSAGAME_TEST_MOVE_H
#include <gtest/gtest.h>
extern "C"{
#include "personnage.h"
#include "collision.h"
#include "prof.h"
#include "DS.h"
#include "GAME.h"
#include "map.h"
#include "move.h"
}

TEST(move_hero,move_up_no_obstacles){
int times=500000000;
Personnage hero;
init_pers(&hero,3,480,28,23,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,4,"../ressource/DS.png");
init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=1;
hero.direction_personnage.down=0;
hero.direction_personnage.right=0;
hero.direction_personnage.left=0;
//test_position(&hero,&prof,&exam,&map);
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
EXPECT_EQ(hero.y_pers,480-SPEED);
while(times>0) times--;
}

/*TEST(move_hero,move_down_no_obstacles){
int times=500000000;
Personnage hero;
init_pers(&hero,3,480,28,23,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,5,"../ressource/DS.png");
init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=0;
hero.direction_personnage.down=1;
hero.direction_personnage.right=0;
hero.direction_personnage.left=0;
//test_position(&hero,&prof,&exam,&map);
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
EXPECT_EQ(hero.y_pers,480+SPEED);
while(times>0) times--;
}

TEST(move_hero,move_left_no_obstacles){
int times=500000000;
Personnage hero;
init_pers(&hero,100,480,28,23,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,5,"../ressource/DS.png");
init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=0;
hero.direction_personnage.down=0;
hero.direction_personnage.right=0;
hero.direction_personnage.left=1;
//test_position(&hero,&prof,&exam,&map);
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
EXPECT_EQ(hero.x_pers,100-SPEED);
while(times>0) times--;
}

TEST(move_hero,move_right_no_obstacles){
int times=500000000;
Personnage hero;
init_pers(&hero,100,480,28,23,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,5,"../ressource/DS.png");
init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=0;
hero.direction_personnage.down=0;
hero.direction_personnage.right=1;
hero.direction_personnage.left=0;
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
EXPECT_EQ(hero.x_pers,100+SPEED);
while(times>0) times--;
}*/

TEST(move_hero,move_left_bounds){
int times=500000000;
Personnage hero;
init_pers(&hero,3,480,28,23,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,5,"../ressource/DS.png");
init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=0;
hero.direction_personnage.down=0;
hero.direction_personnage.right=0;
hero.direction_personnage.left=1;
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
EXPECT_EQ(hero.x_pers,2);
while(times>0) times--;
}

/*TEST(move_hero,move_right_bounds){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,694,75,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; hero_rect.w=3; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,5,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=1;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    EXPECT_EQ(hero.x_pers,695);
    while(times>0) times--;
}

TEST(move_hero,move_up_bounds){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,460,3,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; hero_rect.y=3; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,5,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");    // ça marche pas et je comprends
    hero.direction_personnage.up=1;                                                         // pas pourquoi :((((
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    EXPECT_EQ(hero.y_pers,2);
    while(times>0) times--;
}

TEST(move_hero,move_down_bounds){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,220,694,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; hero_rect.h=3; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,5,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=1;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(hero.y_pers,695);
    while(times>0) times--;
}*/

TEST(move_hero,move_left_wall){
int times=500000000;
Personnage hero;
init_pers(&hero,90,430,3,3,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; hero_rect.x=90; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,5,"../ressource/DS.png");
init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=0;
hero.direction_personnage.down=0;
hero.direction_personnage.right=0;
hero.direction_personnage.left=1;
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
//test_position(&hero,&prof,&exam,&map);
EXPECT_EQ(hero.x_pers,hero_rect.x);
while(times>0) times--;
}

/*TEST(move_hero,move_right_wall){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,176,286,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; hero_rect.x=176; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,5,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=1;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(hero.x_pers,hero_rect.x);
    while(times>0) times--;
}

TEST(move_hero,move_up_wall){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,141,131,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; hero_rect.y=131; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,5,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=1;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(hero.y_pers,hero_rect.y);
    while(times>0) times--;
}

TEST(move_hero,move_down_wall){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,151,562,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag; hero_rect.y=562;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,5,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=1;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(hero.y_pers,hero_rect.y);
    while(times>0) times--;
}*/

TEST(move_hero,move_down_exam){
int times=500000000;
Personnage hero;
init_pers(&hero,53,80,3,3,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,5,"../ressource/DS.png");
init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=0;
hero.direction_personnage.down=1;
hero.direction_personnage.right=0;
hero.direction_personnage.left=0;
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
//test_position(&hero,&prof,&exam,&map);
EXPECT_EQ(levelup_flag,1);
while(times>0) times--;
}

/*TEST(move_hero,move_up_exam){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,473,520,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,24,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=1;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(levelup_flag,1);
    while(times>0) times--;
}

TEST(move_hero,move_left_exam){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,516,662,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,29,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=1;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(levelup_flag,1);
    while(times>0) times--;
}

TEST(move_hero,move_right_exam){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,552,403,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,20,"../ressource/DS.png");
    init_prof(&prof,350,380,40,25,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=1;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(levelup_flag,1);
    while(times>0) times--;
}*/

TEST(move_hero,move_left_to_prof){
int times=500000000;
Personnage hero;
init_pers(&hero,356,381,3,3,SPEED,"testimage");
Prof prof;  DS exam;  MAP map;
SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,20,"../ressource/DS.png");
init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
hero.direction_personnage.up=0;
hero.direction_personnage.down=0;
hero.direction_personnage.right=0;
hero.direction_personnage.left=1;
move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
//test_position(&hero,&prof,&exam,&map);
EXPECT_EQ(die_flag,1);
while(times>0) times--;
}

/*TEST(move_hero,move_right_to_prof){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,346,381,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; int close_request; int die_flag=0; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,20,"../ressource/DS.png");
    init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=1;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(die_flag,1);
    while(times>0) times--;
}

TEST(move_hero,move_up_to_prof){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,351,386,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,20,"../ressource/DS.png");
    init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=1;
    hero.direction_personnage.down=0;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(die_flag,1);
    while(times>0) times--;
}

TEST(move_hero,move_down_to_prof){
    int times=500000000;
    Personnage hero;
    init_pers(&hero,351,374,3,3,SPEED,"testimage");
    Prof prof;  DS exam;  MAP map;
    SDL_Rect hero_rect; int close_request; int die_flag; int levelup_flag;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,20,"../ressource/DS.png");
    init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
    hero.direction_personnage.up=0;
    hero.direction_personnage.down=1;
    hero.direction_personnage.right=0;
    hero.direction_personnage.left=0;
    move_hero(&hero,&hero_rect,&prof,&exam,&map,&close_request,&die_flag,&levelup_flag);
    //test_position(&hero,&prof,&exam,&map);
    EXPECT_EQ(die_flag,1);
    while(times>0) times--;
}*/

TEST(move_prof,move_up_no_obstacles){
int times=500000000;
Prof prof;  DS exam;  MAP map;
SDL_Rect prof_rect; int predirection;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,4,"../ressource/DS.png");
init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
predirection=0;
prof_move(&prof, &predirection, &prof_rect, &map, &exam);
EXPECT_EQ(prof.y_prof,380-SPEED);
while(times>0) times--;
}

/*TEST(move_prof,move_down_no_obstacles){
    int times=500000000;
    Prof prof;  DS exam;  MAP map;
    SDL_Rect prof_rect; int predirection;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,4,"../ressource/DS.png");
    init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
    predirection=1;
    prof_move(&prof, &predirection, &prof_rect, &map, &exam);
    EXPECT_EQ(prof.y_prof,380+SPEED);
    while(times>0) times--;
}

TEST(move_prof,move_left_no_obstacles){
    int times=500000000;
    Prof prof;  DS exam;  MAP map;
    SDL_Rect prof_rect; int predirection;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,4,"../ressource/DS.png");
    init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
    predirection=2;
    prof_move(&prof, &predirection, &prof_rect, &map, &exam);
    EXPECT_EQ(prof.x_prof,350-SPEED);
    while(times>0) times--;
}

TEST(move_prof,move_right_no_obstacles){
    int times=500000000;
    Prof prof;  DS exam;  MAP map;
    SDL_Rect prof_rect; int predirection;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,4,"../ressource/DS.png");
    init_prof(&prof,350,380,3,3,SPEED,"../ressource/prof.png");
    predirection=3;
    prof_move(&prof, &predirection, &prof_rect, &map, &exam);
    EXPECT_EQ(prof.x_prof,350+SPEED);
    while(times>0) times--;
}*/

TEST(move_prof,move_up_wall_or_bounds){
int times=500000000;
Prof prof;  DS exam;  MAP map;
SDL_Rect prof_rect; prof_rect.y=131; int predirection;
init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
init_DS(&exam,4,"../ressource/DS.png");
init_prof(&prof,141,131,3,3,SPEED,"../ressource/prof.png");
predirection=0;
prof_move(&prof, &predirection, &prof_rect, &map, &exam);
EXPECT_EQ(prof.y_prof,prof_rect.y);
while(times>0) times--;
}

/*TEST(move_prof,move_down_wall_or_bounds){
    int times=500000000;
    Prof prof;  DS exam;  MAP map;
    SDL_Rect prof_rect; prof_rect.y=562; int predirection;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,4,"../ressource/DS.png");
    init_prof(&prof,151,562,3,3,SPEED,"../ressource/prof.png");
    predirection=1;
    prof_move(&prof, &predirection, &prof_rect, &map, &exam);
    EXPECT_EQ(prof.y_prof,prof_rect.y);
    while(times>0) times--;
}

TEST(move_prof,move_left_wall_or_bounds){
    int times=500000000;
    Prof prof;  DS exam;  MAP map;
    SDL_Rect prof_rect; prof_rect.x=90; int predirection;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,4,"../ressource/DS.png");
    init_prof(&prof,90,430,3,3,SPEED,"../ressource/prof.png");
    predirection=2;
    prof_move(&prof, &predirection, &prof_rect, &map, &exam);
    EXPECT_EQ(prof.x_prof,prof_rect.x);
    while(times>0) times--;
}

TEST(move_prof,move_right_wall_or_bounds){
    int times=500000000;
    Prof prof;  DS exam;  MAP map;
    SDL_Rect prof_rect; prof_rect.x=173;
    init_map(&map,"../ressource/colored.bmp","../ressource/mapvis.bmp");
    init_DS(&exam,4,"../ressource/DS.png");
    init_prof(&prof,173,286,3,3,SPEED,"../ressource/prof.png");
    int predirection=3;
    prof_move(&prof, &predirection, &prof_rect, &map, &exam);
    EXPECT_EQ(prof.x_prof,prof_rect.x);
    while(times>0) times--;
}*/
#endif /*INSAGAME_TEST_MOVE_H*/
